// Copyright (C) 2003 by ASUSTeK. All rights are reserved.

//////////////////////////////////////////////
// The System Components

var snsridHasFRU =             parent.asID['DUMMY_SENSORID_HASFRU'];
var snsridHasDMI =             parent.asID['DUMMY_SENSORID_HASDMI'];
var snsridHasIPMI =            parent.asID['DUMMY_SENSORID_HASIPMI'];

var snridMBTemperature1 =      (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0140;
var snridMBTemperature2 =      (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0150;
var snridCPUTemperature1 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0200;
var snridCPUTemperature2 =    (parent.asID['ASWM_SNRTYPE_TEMP'] << 16) + 0x0210;

var snridVcoreVoltage =       (parent.asID['ASWM_SNRTYPE_VOLTAGE'] << 16) + 0x0110;

var snridFan1Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0110;
var snridFan2Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0120;
var snridFan3Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0130;
var snridFan4Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0140;
var snridFan5Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0150;
var snridFan6Speed =           (parent.asID['ASWM_SNRTYPE_FAN'] << 16) + 0x0160;


var snridBkplBay1Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1110;
var snridBkplBay2Plug  =       (parent.asID['ASWM_SNRTYPE_PLUGINOUT'] << 16) + 0x1120;

var compPower = new SysComponentInfo ('POWER_FRONT', "parent.I18N['POWERMODULE']", 'info_power.jpg');
var compFan1 = new SysComponentInfo ('FAN1', "parent.once.GSensorNames[parent.once.snridFan1Speed]", 'info_fan_s.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan1Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan1Speed).unit]", snridFan1Speed)
    )
);
var compFan2 = new SysComponentInfo ('FAN2', "parent.once.GSensorNames[parent.once.snridFan2Speed]", 'info_fan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan2Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan2Speed).unit]", snridFan2Speed)
    )
);
var compFan3 = new SysComponentInfo ('FAN3', "parent.once.GSensorNames[parent.once.snridFan3Speed]", 'info_fan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan3Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan3Speed).unit]", snridFan3Speed)
    )
);
var compFan4 = new SysComponentInfo ('FAN4', "parent.once.GSensorNames[parent.once.snridFan4Speed]", 'info_fan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan4Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan4Speed).unit]", snridFan4Speed)
    )
);
var compFan5 = new SysComponentInfo ('FAN5', "parent.once.GSensorNames[parent.once.snridFan5Speed]", 'info_fan1.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan5Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan5Speed).unit]", snridFan5Speed)
	)
);
var compFan6 = new SysComponentInfo ('FAN6', "parent.once.GSensorNames[parent.once.snridFan6Speed]", 'info_fan_s.jpg',
    new Tuple (
        new triple ("parent.I18N['CURRSPEED']", "parent.once.GSensors.idAt(parent.once.snridFan6Speed).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridFan6Speed).unit]", snridFan6Speed)
	)
);


var compMotherboard = new SysComponentInfo ('MOTHERBOARD', "parent.I18N['MOTHERBOARD']", 'info_board.jpg',
    new Tuple (
        new triple ("parent.once.theSysInfo.quadrupleExtraAt(9)", "parent.once.theSysInfo.pairAt(9)"),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature1]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature1).unit]", snridMBTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridMBTemperature2]", "parent.once.GSensors.idAt(parent.once.snridMBTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridMBTemperature2).unit]", snridMBTemperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature1]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).unit]", snridCPUTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature2]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature2).unit]", snridCPUTemperature2)
    )
);
var compMemory;
if (parent.once.hasNewSmBiosMemFeature) {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYARRAY']", "parent.once.findDMI(parent.once.theDMIPhyscalMemArray, 1, 6).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 1, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 2, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 12).value",
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 3, 8).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 11).value + '/' + parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 12).value", 
                "parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 13).extra + '/' + parent.once.smbios_dimmsize2(parent.once.findDMI(parent.once.theDMIMemDeviceData, 4, 8).value)", snsridHasDMI)
        )
    );
} else {
    compMemory = new SysComponentInfo ('DIMM', "parent.I18N['RAMMODULE']", 'info_ddr.jpg',
        new Tuple (
            new triple ("parent.I18N['MEMORYCONTROLLER']", "parent.once.findDMI(parent.once.theDMIMemController, 1, 4).extra", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 1, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 1, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 2, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 2, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 3, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 3, 9).value)", snsridHasDMI),
            new triple ("parent.once.findDMI(parent.once.theDMIMemModules, 4, 4).value", "parent.once.smbios_dimmsize(parent.once.findDMI(parent.once.theDMIMemModules, 4, 9).value)", snsridHasDMI)
        )
    );
}

var compCPU1 = new SysComponentInfo ('CPU1', "parent.I18N['CPU']", 'info_cpu.jpg',
    new Tuple (
        new triple ("parent.I18N['CPU']", "parent.once.findDMI(parent.once.theDMIProcessor, 1, 9).value + ' ' + parent.once.findDMI(parent.once.theDMIProcessor, 1, 13).value + 'Mhz'", snridVcoreVoltage),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature1]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature1).unit]", snridCPUTemperature1),
        new triple ("parent.once.GSensorNames[parent.once.snridCPUTemperature2]", "parent.once.GSensors.idAt(parent.once.snridCPUTemperature2).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridCPUTemperature2).unit]", snridCPUTemperature2),
        new triple ("parent.once.GSensorNames[parent.once.snridVcoreVoltage]", "parent.once.GSensors.idAt(parent.once.snridVcoreVoltage).currvalue + ' ' + parent.once.GResUnit[parent.once.GSensors.idAt(parent.once.snridVcoreVoltage).unit]", snridVcoreVoltage)
    )
);

var compBackplaneBoard = new SysComponentInfo ('BACKPLANEBOARD', "parent.I18N['BACKPLANE']", 'info_bp.jpg',
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "parent.once.findFRU(17, 2, 6)", snsridHasFRU)
    )
);

var compBackplane = new SysComponentInfo ('BACKPLANE', "parent.I18N['BACKPLANE']",
    new SysCompositeImage (
        'IBACKPLANE',
        new Tuple (
            '"<TABLE WIDTH=\\"270\\" height=\\"205\\" BGCOLOR=#DBDBDB BORDER=\\"0\\" CELLPADDING=\\"0\\" CELLSPACING=\\"0\\">"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"100\\" colspan=5><IMG SRC=\\"" + parent.once.imgPath + "hd_f01.gif\\" WIDTH=\\"270\\" HEIGHT=\\"100\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"28\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_f02.gif\\" WIDTH=\\"28\\" HEIGHT=\\"13\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currvalue == 1 ? "hd_ok" : "hd_no_L") + ".gif\\" WIDTH=\\"60\\" HEIGHT=\\"13\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"6\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_f03.gif\\" WIDTH=\\"6\\" HEIGHT=\\"13\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"60\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + (parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currvalue == 1 ? "hd_ok" : "hd_no_M") + ".gif\\" WIDTH=\\"60\\" HEIGHT=\\"13\\" BORDER=\\"0\\"></TD>"',
            '"    <TD WIDTH=\\"116\\" height=\\"13\\"><IMG SRC=\\"" + parent.once.imgPath + "hd_f04.gif\\" WIDTH=\\"116\\" HEIGHT=\\"13\\" BORDER=\\"0\\"></TD></TR>"',
            '"<TR><TD WIDTH=\\"270\\" height=\\"92\\" colspan=5><IMG SRC=\\"" + parent.once.imgPath + "hd_f05.gif\\" WIDTH=\\"270\\" HEIGHT=\\"92\\" BORDER=\\"0\\"></TD></TR></TABLE>"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['BACKPLANE']", "parent.once.findFRU(17, 2, 6)", snsridHasFRU),
        new triple ("parent.I18N['HARDDISK_NUMBER']", 
            "parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currvalue + " +
            "parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currvalue",
            "parent.once.GSensors.idAt(parent.once.snridBkplBay1Plug).currstatus | parent.once.GSensors.idAt(parent.once.snridBkplBay2Plug).currstatus"
        )
    ),
    new Tuple (
        new triple ('IALARM_BACKPLANE_BAY1',
            new triple (new Point (8, 100), '"<img src=\\"" + parent.once.imgPath + "hd_L_e.gif\\">"', 3),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay1Plug)
        ),
        new triple ('IALARM_BACKPLANE_BAY2',
            new triple (new Point (91, 100), '"<img src=\\"" + parent.once.imgPath + "hd_M_e.gif\\">"', 5),
            new pair (parent.asID['IDV_TYPE_SNR'], snridBkplBay2Plug)
        )
    )
);
var compIOConnector = new SysComponentInfo ('IOCONNECTOR', "parent.I18N['IO_CONNECTOR']", 'info_port.jpg',
    new Tuple (
        new triple ("parent.I18N['PS2_PORT']", "2"),
        new triple ("parent.I18N['COM_PORT']", "1"),
        new triple ("parent.I18N['VGA_PORT']", "1"),
        new triple ("parent.I18N['LAN_PORT']", "2"),
        new triple ("parent.I18N['USB_PORT']", "2")
    )
);

var compRiser = new SysComponentInfo ('RISER', "parent.I18N['RISERBOARD']", 'info_riser.jpg',
    new Tuple (
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 1, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 1, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 1, 7).extra", snsridHasDMI),
        new triple ("parent.once.findDMI(parent.once.theDMISlotData, 2, 4).value", "parent.once.findDMI(parent.once.theDMISlotData, 2, 5).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 6).extra + '/' + parent.once.findDMI(parent.once.theDMISlotData, 2, 7).extra", snsridHasDMI)
    )
);

var compIPMI = new SysComponentInfo ('IPMI', "'IPMI'",
    new SysCompositeImage (
        'IPMI',
        new Tuple (
            '"<img src=\\"" + parent.once.imgPath + (parent.once.findIPMI(parent.once.theASMAInfo, 16) ? "info_ipmi_2.jpg" : "info_ipmi.jpg") + "\\">"'
        )
    ),
    new Tuple (
        new triple ("parent.I18N['IPMI_CARDTYPE']", "parent.once.findIPMI(parent.once.theASMAInfo, 16)", snsridHasIPMI)
    )
);

var theSystemComponents = new Tuple (
    compBackplane,
    compBackplaneBoard,
    compIOConnector,
    compRiser,
    compPower,
    compFan1,
    compFan2,
    compFan3,
    compFan4,
    compFan5,
    compFan6,
    compMotherboard,
    compIPMI,
    compMemory,
    compCPU1
);


//////////////////////////////////////////////
// The System with Views

var imgPath = './img/rs120-e4_pa2/';
var imgPanelRear = 'main_rear.gif';
var imgPanelTop = 'main_top.gif';
var imgPanelFront = 'main_front.gif';
var theSystem = new SysModel ('model.jpg', chassis_rackmount);

theSystem.attachView('h',
    new SysModelView (parent.I18N['HOME'], parent.I18N['HOME'])
);

theSystem.attachView('f',
    new SysModelView (parent.I18N['FRONT_VIEW'], parent.I18N['FRONT'],
        'view_front_o.jpg', 'view_front.jpg', 'info_front.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 24, 189, 157, 210), compBackplane)
        ),
        new Tuple (
            new quadruple ('AL_BACKPLANE', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (81, 191))
        )
    )
);

theSystem.attachView('t',
    new SysModelView (parent.I18N['TOP_VIEW'], parent.I18N['TOP'],
        'view_top_o.jpg', 'view_top.jpg', 'info_top.jpg',
        new MapOfAreas (
            new AnArea (new Rect (148,  28, 179,  43), compIPMI),
            new AnArea (new Rect ( 30, 151, 117, 220), compBackplane),
            new AnArea (new Rect ( 37, 136, 113, 163), compBackplaneBoard),
            new AnArea (new Rect ( 28, 114,  45, 129), compFan1),
            new AnArea (new Rect ( 71, 112,  90, 138), compFan2),
            new AnArea (new Rect ( 88, 112, 105, 138), compFan3),
            new AnArea (new Rect (105, 112, 122, 138), compFan4),
            new AnArea (new Rect (121, 112, 137, 138), compFan5),
            new AnArea (new Rect (165, 113, 183, 128), compFan6),
            new AnArea (new Rect (131,  20, 146,  84), compRiser),
            new AnArea (new Rect ( 67,  19,  88,  81), compMemory),
            new AnArea (new Rect ( 97,  73, 127, 103), compCPU1),
            new AnArea (new Rect ( 68,   5, 186, 105), compMotherboard)
        ),
        new Tuple (
            new quadruple ('AL_CPU1TEMP1', parent.asID['IDV_TYPE_SNR'], snridCPUTemperature1, new Point (103, 80)),
            new quadruple ('AL_CPU1TEMP2', parent.asID['IDV_TYPE_SNR'], snridCPUTemperature2, new Point (103, 80)),
            new quadruple ('AL_VCORE1', parent.asID['IDV_TYPE_SNR'], snridVcoreVoltage, new Point (103, 80)),
            new quadruple ('AL_FAN1', parent.asID['IDV_TYPE_SNR'], snridFan1Speed, new Point (28, 113)),
            new quadruple ('AL_FAN2', parent.asID['IDV_TYPE_SNR'], snridFan2Speed, new Point (72, 118)),
            new quadruple ('AL_FAN3', parent.asID['IDV_TYPE_SNR'], snridFan3Speed, new Point (88, 118)),
            new quadruple ('AL_FAN4', parent.asID['IDV_TYPE_SNR'], snridFan4Speed, new Point (104, 118)),
            new quadruple ('AL_FAN5', parent.asID['IDV_TYPE_SNR'], snridFan5Speed, new Point (120, 118)),
            new quadruple ('AL_FAN6', parent.asID['IDV_TYPE_SNR'], snridFan6Speed, new Point (166, 112)),
            new quadruple ('AL_MBTEMP1', parent.asID['IDV_TYPE_SNR'], snridMBTemperature1, new Point (112, 46)),
            new quadruple ('AL_MBTEMP2', parent.asID['IDV_TYPE_SNR'], snridMBTemperature2, new Point (112, 46)),
            new quadruple ('AL_BACKPLANE', parent.asID['IDV_TYPE_SNRGROUP'], parent.asLbID['ASWM_SNRGROUP_BACKPLANE1'], new Point (64, 177))
        )
    )
);

theSystem.attachView('r',
    new SysModelView (parent.I18N['REAR_VIEW'], parent.I18N['REAR'],
        'view_rear_o.jpg', 'view_rear.jpg', 'info_rear.jpg',
        new MapOfAreas (
            new AnArea (new Rect ( 26, 199, 209, 214), compIOConnector),
            new AnArea (new Rect ( 95, 188, 162, 203), compRiser)
        )
    )
);


//////////////////////////////////////////////
// The System View Addon Item except default Item

var theSysViewInfoAddon = new Tuple (
    new GSysViewHealth ('h',
        "parent.I18N['BACKPLANE']", "(parent.once.theFRUInfo ? parent.once.findFRU(17, 2, 6) : '')"
    ),

    new GSysViewHealth ('f',
        "parent.I18N['BACKPLANE']", "(parent.once.theFRUInfo ? parent.once.findFRU(17, 2, 6) : '')",
        "parent.I18N['BACKPLANE_NUMBER']", "1",
        "parent.I18N['USB_PORT']", "2"
    ),
    new GSysViewHealth ('r',
        "parent.I18N['PS2_PORT']", "2",
        "parent.I18N['COM_PORT']", "1",
        "parent.I18N['VGA_PORT']", "1",
        "parent.I18N['LAN_PORT']", "2",
        "parent.I18N['USB_PORT']", "2"
    )
);


//////////////////////////////////////////////
// The System Backplane structure

var theSysBackplane = new Array ();

theSysBackplane[parent.asLbID['ASWM_SNRGROUP_BACKPLANE1']] = new SysBackplane (
    'BP2LSA-R10', 'h_bp.jpg', compBackplane,
    new Tuple,
    new Tuple (
        new Tuple (snridBkplBay1Plug),
        new Tuple (snridBkplBay2Plug)
    ),
    new triple (parent.asID['ASWM_CFGGROUP_ASMA'] << 16, parent.asID['ASWM_SNRGROUP_BACKPLANE1'] << 16, parent.asID['ASWM_CFGTYPE_BACKPLANE'])
);
